## List Custom CSRs `client.CustomCsrs.List(ctx, params) (*V4PagePaginationArray[CustomCsrListResponse], error)` **get** `/{accounts_or_zones}/{account_or_zone_id}/custom_csrs` List all custom Certificate Signing Requests (CSRs) for an account or zone. ### Parameters - `params CustomCsrListParams` - `AccountID param.Field[string]` Path param: The Account ID to use for this endpoint. Mutually exclusive with the Zone ID. - `ZoneID param.Field[string]` Path param: The Zone ID to use for this endpoint. Mutually exclusive with the Account ID. - `Page param.Field[float64]` Query param: Page number of paginated results. - `PerPage param.Field[float64]` Query param: Number of custom CSRs per page. ### Returns - `type CustomCsrListResponse struct{…}` A custom Certificate Signing Request (CSR). - `ID string` Custom CSR identifier tag. - `CreatedAt Time` When the CSR was created. - `KeyType CustomCsrListResponseKeyType` The key algorithm used to generate the CSR. - `const CustomCsrListResponseKeyTypeRsa2048 CustomCsrListResponseKeyType = "rsa2048"` - `const CustomCsrListResponseKeyTypeP256v1 CustomCsrListResponseKeyType = "p256v1"` - `AccountTag string` Account identifier associated with this CSR. - `CommonName string` The common name (domain) for the CSR. - `Country string` Two-letter ISO 3166-1 alpha-2 country code. - `Csr string` The PEM-encoded Certificate Signing Request. - `Description string` Optional description for the CSR. - `Locality string` City or locality name. - `Name string` Human-readable name for the CSR. - `Organization string` Organization name. - `OrganizationalUnit string` Organizational unit name. - `Sans []string` Subject Alternative Names included in the CSR. - `State string` State or province name. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/custom_csrs" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) page, err := client.CustomCsrs.List(context.TODO(), custom_csrs.CustomCsrListParams{ }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "id": "7b163417-1d2b-4c84-a38a-2fb7a0cd7752", "created_at": "2024-01-15T10:30:00Z", "key_type": "rsa2048", "account_tag": "23e087bd19bc1d40ae95b6f297263ceb", "common_name": "example.com", "country": "US", "csr": "-----BEGIN CERTIFICATE REQUEST-----\nMIICYzCCAUsCAQAwHj...", "description": "CSR for example.com wildcard", "locality": "San Francisco", "name": "My Custom CSR", "organization": "Cloudflare, Inc.", "organizational_unit": "Engineering", "sans": [ "example.com", "www.example.com" ], "state": "California" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ```